﻿using UnityEngine;
using System.Collections;

public class GDisplayWave : MonoBehaviour {

    GWaveController wave_display;
    [SerializeField]
    GameObject chart;

    [SerializeField]
    GameObject UI_interval;

    [SerializeField]
    GameObject UI_Max_injections;


    IEnumerator rutine_show;

	// Use this for initialization
	void Start () {
        wave_display = GetComponentInChildren<GWaveController>();
        ClearScreen();
	}

    void ShowInjection()
    {
        ClearScreen();
        UI_Max_injections.SetActive(true);
    }

    public void MaxInjections()
    {
        ClearScreen();
        ShowInjection();

        if (rutine_show != null)
        {
            StopCoroutine(rutine_show);
        }

        rutine_show = RutineShowNext();
        StartCoroutine(rutine_show);
    }

    public void ShowPatientKilled()
    {
        ClearScreen();

        if (rutine_show != null)
        {
            StopCoroutine(rutine_show);
        }

        rutine_show = RutineShowNext();
        StartCoroutine(rutine_show);
    }

    public void ShowNextWave()
    {
        ShowInterval();

        if (rutine_show != null)
        {
            StopCoroutine(rutine_show);
        }

        rutine_show = RutineShowNext();
        StartCoroutine(rutine_show);
    }

    void ClearScreen()
    {
        wave_display.gameObject.SetActive(false);
        chart.SetActive(false);
        UI_interval.SetActive(false);
        UI_Max_injections.SetActive(false);
    }

    void ShowInterval()
    {
        wave_display.gameObject.SetActive(false);
        chart.SetActive(false);
        UI_interval.SetActive(true);
    }

    void ShowWave()
    {
        wave_display.gameObject.SetActive(true);
        chart.SetActive(true);
        UI_interval.SetActive(false);
    }

    IEnumerator RutineShowNext()
    {
        float actual_time = 0f;

        while (true)
        {
            actual_time += Time.deltaTime;
            if (actual_time >= GGameLogic.SECONDS_TO_WAIT_AFTER_CORRECT)
            {
                break;
            }
            yield return null;
        }

        ClearScreen();
        ShowWave();
    }
}
