﻿using UnityEngine;
using System.Collections;
using UnityEngine.UI;
using UnityEngine.Events;

public class GUIFade : MonoBehaviour {

    CanvasGroup canvas_group_fade_bg;

    IEnumerator fade_rutine;

    float time_fade;
    float target;

    UnityAction callback;

    void Awake()
    {
        canvas_group_fade_bg = GetComponentInChildren<CanvasGroup>();
    }

	// Use this for initialization
	void Start () {        

	}
	
	// Update is called once per frame
	void Update () {
	
	}

    public void SimpleFadeIn(float _time,UnityAction _callback = null)
    {
        Fade(0f, _time,_callback);
    }

    public void SimpleFadeOut(float _time,UnityAction _callback = null)
    {
        Fade(1f, _time,_callback);
    }

    public void FromTo(float _from, float _to, float _time,UnityAction _callback = null)
    {
        canvas_group_fade_bg.alpha = _from;
        Fade(_to, _time,_callback);
    }

    public void Fade(float _target, float _time,UnityAction _callback = null)
    {
        target = _target;
        time_fade = _time;
        callback = _callback;        

        if (fade_rutine != null)
        {
            StopCoroutine(fade_rutine);
        }

        fade_rutine = FadeRutine();
        StartCoroutine(fade_rutine);
    }

    IEnumerator FadeRutine()
    {
        float delta = target - canvas_group_fade_bg.alpha / time_fade;

        float actual_time = 0f;

        while (true)
        {
            actual_time += Time.deltaTime;
            //canvas_group_fade_bg.alpha = Mathf.Lerp(canvas_group_fade_bg.alpha, target, actual_time);            

            canvas_group_fade_bg.alpha += delta * Time.deltaTime;

            if (actual_time > time_fade)
            {
                canvas_group_fade_bg.alpha = target;
                if (callback != null)
                {
                    callback.Invoke();
                }
                break;
            }
            yield return null;
        }
    }
}
