﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class GButtonLightsInteract : GBasicObjectToInteract {

    GGameLogic game_logic;

    [SerializeField]
    List<Light> list_lights_linked = new List<Light>();

    bool lights_state;

    Animator animator_button;

	// Use this for initialization
	public override void Start () {

        game_logic = GSingleton.Instance.GameLogic;
        SetLightsAsValue();
        animator_button = GetComponent<Animator>();
	}

    public override void InteractLeftClick()
    {
        base.InteractLeftClick();
        lights_state = !lights_state;
        SetLightsAsValue();
        game_logic.TurnLights(lights_state);
        animator_button.SetTrigger("Push");
    }

    void SetLightsAsValue()
    {
        for (int i = 0; i < list_lights_linked.Count; i++)
        {
            list_lights_linked[i].gameObject.SetActive(lights_state);
        }
    }
}
