﻿using UnityEngine;
using System.Collections;

public class GPatientReportInteract : GObjectCloseCamera {
  
    GWaveController wave;
    public GWaveController Wave {
        get { return wave; }
    }

	// Use this for initialization
	public override void Start () {    
        wave = GetComponentInChildren<GWaveController>(true);
        wave.gameObject.SetActive(false);
        ClearScreen();     
        base.Start();
	}

    [SerializeField]
    GameObject chart;

    [SerializeField]
    GameObject UI_interval;
   
    IEnumerator rutine_show;
   
    // Update is called once per frame
    public override void Update () {
        base.Update();       
	}

    public override void InteractLeftClick()
    {
        base.InteractLeftClick();      
    } 

    public void KillPatient()
    {
        wave.SetWaveParameters(Random.Range(1, 6) * 10, Random.Range(1, 6));

        ClearScreen();

        if (rutine_show != null)
        {
            StopCoroutine(rutine_show);
        }

        rutine_show = RutineShowNext();
        StartCoroutine(rutine_show);
    }

    public void SetNewPatient()
    {
        wave.SetWaveParameters(Random.Range(1, 6) * 10, Random.Range(1, 6));     

        ShowInterval();

        if (rutine_show != null)
        {
            StopCoroutine(rutine_show);
        }

        rutine_show = RutineShowNext();
        StartCoroutine(rutine_show);
    }

    void ClearScreen()
    {
        wave.gameObject.SetActive(false);
        chart.SetActive(false);
        UI_interval.SetActive(false);
    }

    void ShowInterval()
    {
        wave.gameObject.SetActive(false);
        chart.SetActive(false);
        UI_interval.SetActive(true);
    }

    void ShowWave()
    {
        wave.gameObject.SetActive(true);
        chart.SetActive(true);
        UI_interval.SetActive(false);
    }  

    IEnumerator RutineShowNext()
    {
        float actual_time = 0f;

        while (true)
        {
            actual_time += Time.deltaTime;
            if (actual_time >= GGameLogic.SECONDS_TO_WAIT_AFTER_CORRECT)
            {
                break;
            }
            yield return null;
        }

        ShowWave();
    }
}
