﻿using UnityEngine;
using System.Collections;
using UnityEngine.Events;

public class GWorldInteraction : MonoBehaviour {

    Ray ray_to_cast;
    RaycastHit ray_hit;

    [SerializeField]
    LayerMask layer_collide;

    GIObjectToInteract object_over;

    UnityEvent on_escape = new UnityEvent();
    public UnityEvent OnEscape { get { return on_escape; } }

    bool can_interact = true;
    public bool CanInteract { get { return can_interact; } set { can_interact = value; } }

    void Awake()
    {
        GSingleton.Instance.WorldInteraction = this;
    }

	// Use this for initialization
	void Start () {
	
	}
	
	// Update is called once per frame
	void Update () {

        if (CanInteract == true)
        {
            CheckWorldInteraction();

            if (Input.GetMouseButtonDown(0))
            {
                if (object_over != null)
                {
                    object_over.InteractLeftClick();
                }
            }

            if (Input.GetMouseButtonDown(1))
            {
                if (object_over != null)
                {
                    object_over.InteractRightClick();
                }
            }

            if (Input.GetKeyDown(KeyCode.Escape))
            {
                if (on_escape != null)
                {
                    on_escape.Invoke();
                }
            }
        }
    }

    void CheckWorldInteraction()
    {
        ray_to_cast = GetComponent<Camera>().ScreenPointToRay(Input.mousePosition);
                
        if (Physics.Raycast(ray_to_cast, out ray_hit, 100f, layer_collide))
        {
            GIObjectToInteract object_to_interact = ray_hit.transform.GetComponent<GIObjectToInteract>();
            if (object_to_interact != null)
            {
                if (object_to_interact.IsLightDependant == true && GSingleton.Instance.GameLogic.AreLightsOn == false)
                {
                    return;
                }

                if (object_over != null)
                {
                    if (object_over != object_to_interact)//Other object is in front
                    {
                        object_over.ReleaseOver();
                    }
                    object_over = object_to_interact;
                    object_over.OnOver();
                }
                else
                {
                    object_over = object_to_interact;
                    object_over.OnOver();
                }
            }
            else
            {
                if (object_over != null)
                {
                    object_over.ReleaseOver();
                    object_over = null;
                }
            }
        }
        else
        {
            if (object_over != null)
            {
                object_over.ReleaseOver();
                object_over = null;
            }
        }
    }
}
